#!/bin/sh

#******************************************************************************************
# (c) Copyright 2020  Micro Focus or one of its affiliates.
#
# The only warranties for products and services of Micro Focus and its affiliates and
# licensors (“Micro Focus”) are as may be set forth in the express warranty statements
# accompanying such products and services. Nothing herein should be construed as
# constituting an additional warranty. Micro Focus shall not be liable for technical
# or editorial errors or omissions contained herein. The information contained herein
# is subject to change without notice.
#
# Except as specifically indicated otherwise, this document contains confidential information
# and a valid license is required for possession, use or copying. If this work is provided to
# the U.S. Government, consistent with FAR 12.211 and 12.212, Commercial Computer Software,
# Computer Software Documentation, and Technical Data for Commercial Items are licensed
# to the U.S. Government under vendor's standard commercial license.
#
#******************************************************************************************

function _cifscomplete_()
{

	local cur prev prev2 prev3 prev4 prev5 prev6 prev7 prev8 prev9 prev10 prev11

	if [ $COMP_CWORD -eq 1 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
	elif [ $COMP_CWORD -eq 2 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
	elif [ $COMP_CWORD -eq 3 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
	elif [ $COMP_CWORD -eq 4 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
	elif [ $COMP_CWORD -eq 5 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
	elif [ $COMP_CWORD -eq 6 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
		prev5=${COMP_WORDS[COMP_CWORD-5]}
	elif [ $COMP_CWORD -eq 7 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
		prev5=${COMP_WORDS[COMP_CWORD-5]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
	elif [ $COMP_CWORD -eq 8 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev7=${COMP_WORDS[COMP_CWORD-7]}
	elif [ $COMP_CWORD -eq 9 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
		prev7=${COMP_WORDS[COMP_CWORD-7]}
		prev8=${COMP_WORDS[COMP_CWORD-8]}
	elif [ $COMP_CWORD -eq 12 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
		prev9=${COMP_WORDS[COMP_CWORD-9]}
		prev10=${COMP_WORDS[COMP_CWORD-10]}
		prev11=${COMP_WORDS[COMP_CWORD-11]}
	fi

	COMPREPLY=()

	options="--share
	-sl
	-sln
	-sap
	-srn
	-s
	-e
	--guest-login=yes/no
	-a
	--add
	-r
	--remove
	-av
	-rv
	-o
	--oper-params
	-g
	--enable-smbsigning=no/optional/force
	-L
	--lm=0/4/5
	-y
	-k
	--set-cache
	-t
	--auditing=yes/no
	-S
	--sync=yes/no
	--enable-range-lock-mask=yes/no
	--csc=0/1/2/3
	-i
	-UT
	--block-invalid-users
	-Uan
	-Urn
	-Ul
	-d
	--dump-statistics=fh/fp/dc
	-C
	--Conn
	-Cl
	-ClA
	-ClE
	-Cn
	-Flp
	--Files
	-Flv
	-Fln
	-Flop
	-Flov
	-Flon
	-FCp
	-FCn
	-FCv
	--info-level-passthru=yes/no
	--list-servers
	--share-vols-default=SERVER_NAME
	--dialect=SMB/SMB2/SMB3
	--user-quota-sync
	--user-quota-view
	--change-notify
	--enum-shares-over-nullsession=yes/no
	--oplock-lease-break-ack-timeout=time_in_seconds
	--leasing=yes/no
	--negotiate-ntstatus=yes/no
	--dfs-support=yes/no
	--dns-suffix=DNS-SUFFIX
	--display-user-addr=yes/no
	--alternate-data-stream-enabled=yes/no
	--disable-smbv1-sessions=win-mac/mac/none/all
	--encrypt-data=yes/no
	--reject-unencrypted-access=yes/no
	--log-level
	--dos-names=yes/no
	--disable-ntlmssp=yes/no
	--block-unmanaged-cis-reads=yes/no
	--map-adsessions-to-edir=yes/no/fallback
	--zerocopy=yes/no
	--check-share-visibility-rights=yes/no
	--directory-leasing=yes/no
	-u
	--usage
	-h
	--help"

share_add="--path=PATH
	   --comment=COMMENT
	   --vserver=VIRTUALSERVERFDN
	   --name=SHARENAME"

	if [ $COMP_CWORD -eq 1 ]
	then
		COMPREPLY=( $(compgen -W "${options}" -- ${cur}) )
	elif [ $COMP_CWORD -eq 2 ]
	then
		case "$prev" in
			"--share")
				COMPREPLY=( $(compgen -W "--list --remove --add --enable-encryption=yes/no --folder-redirection=yes/no --atm-backup=yes/no -l" -- ${cur}) )
				;;
			"-s")
				COMPREPLY=( $(compgen -W "--enable-encryption=yes/no --folder-redirection=yes/no --atm-backup=yes/no -l" -- ${cur}) )
				;;
			"-sap")
				COMPREPLY=( $(compgen -W "PATH" -- ${cur}) )
				;;
			"-sln" | "-srn")
				COMPREPLY=( $(compgen -W "SHARENAME" -- ${cur}) )
				;;
			"-e")
				COMPREPLY=( $(compgen -W "yes/no" -- ${cur}) )
				;;
			"-a" | "-r")
				COMPREPLY=( $(compgen -W "-v -D" -- ${cur}) )
				;;
			"--add" | "--remove")
				COMPREPLY=( $(compgen -W "--dns-name=DNSNAME --vserver==VIRTUALSERVERFDN" -- ${cur}) )
				;;
			"-av" | "-rv")
				COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
				;;
			"-g")
				COMPREPLY=( $(compgen -W "no/optional/force" -- ${cur}) )
				;;
			"-L")
				COMPREPLY=( $(compgen -W "0/4/5" -- ${cur}) )
				;;
			"-y" | "-t" | "-S")
				COMPREPLY=( $(compgen -W "yes/no" -- ${cur}) )
				;;
			"--set-cache" | "-k")
				COMPREPLY=( $(compgen -W "SDIRCACHE=value  DIRCACHE=value  FILECACHE=value" -- ${cur}) )
				;;
			"-UT")
				COMPREPLY=( $(compgen -W "TIMEOUT-PERIOD" -- ${cur}) )
				;;
			"--block-invalid-users")
				COMPREPLY=( $(compgen -W "--timeout-period=TIMEOUT-PERIOD --add -a --remove -r --list -l" -- ${cur}) )
				;;
			"-Uan" | "-Urn")
				COMPREPLY=( $(compgen -W "USER-NAME" -- ${cur}) )
				;;
			"-d")
				COMPREPLY=( $(compgen -W "fh fp dc" -- ${cur}) )
				;;
			"--Conn")
				COMPREPLY=( $(compgen -W "--list --connection=CONNECTION-ID" -- ${cur}) )
				;;
			"-Cn")
				COMPREPLY=( $(compgen -W "CONNECTION-ID" -- ${cur}) )
				;;
			"-Flp" | "-Flop" | "-FCp")
				COMPREPLY=( $(compgen -W "FILE-PATH" -- ${cur}) )
				;;
			"--Files")
				COMPREPLY=( $(compgen -W "--list --Close" -- ${cur}) )
				;;
			"-Flv" | "-Flov" | "-FCv")
				COMPREPLY=( $(compgen -W "VOLUME-NAME" -- ${cur}) )
				;;
			"-Fln" | "-Flon" | "-FCn")
				COMPREPLY=( $(compgen -W "CONNECTION-ID" -- ${cur}) )
				;;
			"--user-quota-sync")
				COMPREPLY=( $(compgen -W "primary_volume" -- ${cur}) )
				;;
			"--change-notify")
				COMPREPLY=( $(compgen -W "yes/no" -- ${cur}) )
				;;
			"--log-level")
				COMPREPLY=( $(compgen -W "error/debug/info" -- ${cur}) )
				;;
			"-i")
				COMPREPLY=( $(compgen -W "readProxy" -- ${cur}) )
				;;
			"--user-quota-view")
				COMPREPLY=( $(compgen -W "volume" -- ${cur}) )
				;;
		esac
	elif [ $COMP_CWORD -eq 3 ]
	then
	case "$prev2" in
			"--share" | "s")
				case "$prev" in
					"--list" | "-l")
						COMPREPLY=( $(compgen -W "--name=SHARENAME" -- ${cur}) )
						;;
					"--add")
						COMPREPLY=( $(compgen -W "${share_add}" -- ${cur}) )
						;;
					"--remove")
						COMPREPLY=( $(compgen -W "--name=SHARENAME --vserver=VIRTUALSERVERFDN" -- ${cur}) )
						;;
				esac
				;;
			"-srn")
				COMPREPLY=( $(compgen -W "-v" -- ${cur}) )
				;;
			"-sap")
				COMPREPLY=( $(compgen -W "-n -c -v" -- ${cur}) )
				;;
			"-a" | "-r")
				case "$prev" in
					"-D")
						COMPREPLY=( $(compgen -W "DNSNAME" -- ${cur}) )
						;;
					"-v")
						COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
						;;
				esac
				;;
			"-av" | "-rv")
				COMPREPLY=( $(compgen -W "-I" -- ${cur}) )
				;;
			"--block-invalid-users")
				case "$prev" in
					"--add" | "--remove" | "-a" | "-r")
						COMPREPLY=( $(compgen -W "--name=USER-NAME" -- ${cur}) )
						;;
				esac
				;;
			"--Conn")
				case "$prev" in
					"--list")
						COMPREPLY=( $(compgen -W "--ad --eDir" -- ${cur}) )
						;;
				esac
				;;
			"--Files")
				case $prev in
					"--list")
						COMPREPLY=( $(compgen -W "--oplock-lease-info --path=FILE-PATH --volume=VOLUME-NAME --connection=CONNECTION-ID" -- ${cur}) )
						;;
					 "--Close")
						COMPREPLY=( $(compgen -W "--path=FILE-PATH --volume=VOLUME-NAME --connection=CONNECTION-ID" -- ${cur}) )
						;;
				esac
				;;
			"--user-quota-sync")
				COMPREPLY=( $(compgen -W "--percent" -- ${cur}) )
				;;
	esac
	elif [ $COMP_CWORD -eq 4 ]
	then
	case "$prev3" in
			"-srn")
				COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
				;;
			"-sap")
				if [ "$prev" == "-n" ]
				then
					COMPREPLY=( $(compgen -W "SHARENAME" -- ${cur}) )
				elif [ "$prev" == "-c" ]
				then
					COMPREPLY=( $(compgen -W "COMMENT" -- ${cur}) )
				elif [ "$prev" == "-v" ]
				then
					COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
				fi
				;;
			"-a" | "-r")
				case "$prev2" in
					"-D" | "-v")
						COMPREPLY=( $(compgen -W "-I" -- ${cur}) )
						;;
				esac
				;;
			"-av" | "-rv")
					COMPREPLY=( $(compgen -W "VIRTUALSERVERIP" -- ${cur}) )
					;;
			"--user-quota-sync")
					case "$prev" in
						"--percent")
							COMPREPLY=( $(compgen -W "percentage" -- ${cur}) )
							;;
					esac
					;;
			"--share-vols-default")
					COMPREPLY=( $(compgen -W "--value=yes/no" -- ${cur}) )
					;;
			"--Files")
					case "$prev" in
						"--oplock-lease-info")
							COMPREPLY=( $(compgen -W "--path=FILE-PATH --volume=VOLUME-NAME --connection=CONNECTION-ID" -- ${cur}) )
							;;
					esac
					;;
	esac
	elif [ $COMP_CWORD -eq 5 ]
	then
	case "$prev4" in
			"--share")
				if [ $prev3 == "--enable-encryption" ] || [ $prev3 == "--folder-redirection" ] || [ $prev3 == "--atm-backup" ]
				then
					COMPREPLY=( $(compgen -W "--name=SHARENAME" -- ${cur}) )
				fi
				;;
			"-s")
				if [ $prev3 == "--enable-encryption" ] || [ $prev3 == "--folder-redirection" ] || [ $prev3 == "--atm-backup" ]
				then
					COMPREPLY=( $(compgen -W "-n" -- ${cur}) )
				fi
				;;
			"-sap")
				if [ "$prev2" == "-n" ]
				then
					COMPREPLY=( $(compgen -W "-c -v" -- ${cur}) )
				elif [ "$prev2" == "-c" ]
				then
					COMPREPLY=( $(compgen -W "-n -v" -- ${cur}) )
				elif [ "$prev2" == "-v" ]
				then
					COMPREPLY=( $(compgen -W "-n -c" -- ${cur}) )
				fi
				;;
			"--add" | "--remove")
				case $prev3 in
					"--dns-name")
						COMPREPLY=( $(compgen -W "--ip-addr=IPADDR" -- ${cur}) )
						;;
					"--vserver")
						COMPREPLY=( $(compgen -W "---ip-addr=VIRTUALSERVERIP" -- ${cur}) )
						;;
				esac
				;;
			"-a" | "-r")
				case $prev3 in
					"-D")
						COMPREPLY=( $(compgen -W "IPADDR" -- ${cur}) )
						;;
					"-v")
						COMPREPLY=( $(compgen -W "VIRTUALSERVERIP" -- ${cur}) )
						;;
				esac
				;;
			"--share-vols-default")
				COMPREPLY=( $(compgen -W "--value=yes/no" -- ${cur}) )
				;;
	esac
	elif [ $COMP_CWORD -eq 6 ]
	then
	case "$prev5" in
			"--share")
				case "$prev4" in
					"--remove")
						if [ $prev3 == "--name" ]
						then
							COMPREPLY=( $(compgen -W "--vserver=VIRTUALSERVERFDN" -- ${cur}) )
						elif [ $prev3 == "--vserver" ]
						then
							COMPREPLY=( $(compgen -W "--name=SHARENAME" -- ${cur}) )
						fi
						;;
					"--add")
						COMPREPLY=( $(compgen -W "${share_add}" -- ${cur}) )
						;;
				esac
				;;
			"-s")
				case "$prev4" in
					"--enable-encryption" | "--folder-redirection" | "--atm-backup")
						COMPREPLY=( $(compgen -W "SHARENAME" -- ${cur}) )
						;;
				esac
				;;
			"-sap")
				if [ "$prev" == "-n" ]
				then
					COMPREPLY=( $(compgen -W "SHARENAME" -- ${cur}) )
				elif [ "$prev" == "-c" ]
				then
					COMPREPLY=( $(compgen -W "COMMENT" -- ${cur}) )
				elif [ "$prev" == "-v" ]
				then
					COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
				fi
				;;
	esac
	elif [ $COMP_CWORD -eq 7 ]
	then
	case "$prev6" in
			"-sap")
				if [[ "$prev4" == "-n" && "$prev2" == "-c" ]] || [[ "$prev4" == "-c" && "$prev2" == "-n" ]]
				then
					COMPREPLY=( $(compgen -W "-v" -- ${cur}) )
				elif [[ "$prev4" == "-v" && "$prev2" == "-c" ]] || [[ "$prev4" == "-c" && "$prev2" == "-v" ]]
				then
					COMPREPLY=( $(compgen -W "-n" -- ${cur}) )
				elif [[ "$prev4" == "-n" && "$prev2" == "-v" ]] || [[ "$prev4" == "-v" && "$prev2" == "-n" ]]
				then
					COMPREPLY=( $(compgen -W "-c" -- ${cur}) )
				fi
				;;
	esac
	elif [ $COMP_CWORD -eq 8 ]
	then
	case "$prev7" in
			"-sap")
				if [ "$prev" == "-n" ]
				then
					COMPREPLY=( $(compgen -W "SHARENAME" -- ${cur}) )
				elif [ "$prev" == "-c" ]
				then
					COMPREPLY=( $(compgen -W "COMMENT" -- ${cur}) )
				elif [ "$prev" == "-v" ]
				then
					COMPREPLY=( $(compgen -W "VIRTUALSERVERFDN" -- ${cur}) )
				fi
				;;
	esac
	elif [ $COMP_CWORD -eq 9 ]
	then
	case "$prev8" in
			"--share" | "-s")
				case "$prev7" in
					"--add")
						COMPREPLY=( $(compgen -W "${share_add}" -- ${cur}) )
						;;
				esac
				;;
	esac
	elif [ $COMP_CWORD -eq 12 ]
	then
	case "$prev11" in
			"--share" | "-s")
				case "$prev10" in
					"--add")
						COMPREPLY=( $(compgen -W "${share_add}" -- ${cur}) )
						;;
				esac
				;;
	esac
	fi

}

complete -F _cifscomplete_ novcifs
